chiark / gitweb /
el/dot-emacs.el: Highlight `:' as punctuation in Perl.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
82c688c7 13: ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
188ebb31
MW
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
f617db13
MW
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
852cd5fb 119echo " all done."
f617db13 120
ce178f96
MW
121###--------------------------------------------------------------------------
122### Install global configuration.
123
f141fe0f
MW
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
ce178f96 132## Symlink the various dotfiles into place
852cd5fb 133dotfiles="
be7dba95 134 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 135 emacs emacs-calc vm gnus.el ercrc.el
4fc3203b 136 vimrc mg zile lesskey
30169591 137 ditz-config
ce39049e 138 mailrc signature muttrc
ce178f96 139 cgrc tigrc
e7d23024 140 gdbinit
8a7e906d 141 guile
1d89ce86 142 rcrc
5d25e440 143 toprc
a6a6806a 144 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
f56d38cd 145 pulse-daemon.conf:.pulse/daemon.conf
cbffcf2b 146 aspell.conf
78719982 147 tclshrc:.tclshrc tclshrc:.wishrc
ccaac00b
MW
148 lisp-init.lisp:.cmucl-init.lisp
149 lisp-init.lisp:.sbclrc
150 lisp-init.lisp:.clisprc.lisp
f6335a0c 151 lisp-init.lisp:.eclrc
b5bf3445 152 swank.lisp
3ec64a11 153 w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
2425eca9 154 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 155[ "$xstuff" ] && dotfiles="$dotfiles
cd38b61d 156 xinitrc xsession xmodmap Xdefaults vncrc vncsession
5e23020b 157 fonts.conf
e517857c 158 stalonetrayrc
1c6b19d4 159 putty-defaults:.putty/sessions/Default%20Settings
2e60c7f3 160 mdw.session:.config/gnome-session/sessions/mdw.session
7cfa1f1a 161 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 162 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 163 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 164 e16-bindings:.e16/bindings.cfg"
f617db13
MW
165echo "Installing dotfiles..."
166for d in $dotfiles; do
739bccbf
MW
167 target=.$d
168 case $d in
169 *:*) target=${d#*:} d=${d%%:*};;
170 esac
171 ft=$HOME$sub/$target
172 dir=${ft%/*}
173 mkdir -p $dir
99063107 174 ln -s $here/dot/$d $ft.new
739bccbf
MW
175 mv $ft.new $ft
176 echo " $target"
f617db13 177done
852cd5fb 178echo " all done."
f617db13 179
403dc178
MW
180## Substitute things which need substituting.
181dotfilessubst="
182 gitconfig
8508a859 183 mykermrc
403dc178
MW
184 pulse-default.pa.in:.pulse/default.pa"
185echo "Installing dotfiles with substitutions..."
186for d in $dotfilessubst; do
187 case $d in
188 *:*) target=${d#*:} d=${d%%:*};;
189 *) target=.$d d=$d.in;;
190 esac
191 ft=$HOME$sub/$target
192 dir=${ft%/*}
193 mkdir -p $dir
194 sed "
2b5d4580
MW
1951i\\
196### generated by $here/setup; do not edit!\\
403dc178
MW
197
198/@home@/ s\a\a$HOME\ag
73165cde 199/@profile@/ s\a\a$here\ag
bf674ae1 200/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
403dc178
MW
201" dot/$d >$ft.new
202 mv $ft.new $ft
203 echo " $target"
204done
205echo " all done."
206
f4e43257 207## Symlink backgrounds.
960af1a5 208backgrounds="
5236501e 209 bsg-supper.jpg
9fe91389 210 harley-quinn.jpg
56c871ef 211 hypatia.jpg
7bdd0453 212 jue-peek.jpg
9f56284f 213 lilith.jpg
7bdd0453
MW
214 lovelace.jpg
215 medusa.jpg
216 noodly.jpg
217 rayne.jpg
218"
f4e43257
MW
219if [ "$xstuff" ]; then
220 echo "Installing backgrounds..."
221 for b in $backgrounds; do
222 for e in enlightenment e16; do
223 dir=$HOME$sub/.$e/backgrounds
224 t=$dir/$b
225 mkdir -p $dir
99063107 226 ln -s $here/bg/$b $t.new
f4e43257
MW
227 mv $t.new $t
228 done
229 echo " $b"
230 done
231 echo " all done."
232fi
233
ce178f96
MW
234###--------------------------------------------------------------------------
235### Install useful scripts included in this package.
236
e04c4857 237scripts="
547fb8af 238 mdw-editor
b20bfd83 239 mdw-pager
b056f5c4 240 mdw-conf
7ee12623 241 mdw-build
c4e84cb1 242 emacsclient-hack
8e08f814 243 movemail-hack
aaa2d943 244 sendmail-hack
68b2e9e6 245 aspell-hack
285a1386
MW
246 emerge-hack
247 lesspipe.sh
6a5170a8 248 run-with-shell-env
285a1386 249 start-ssh-agent
6a5170a8 250 start-ssh-pageant
4cdeb0d0 251 svnwrap
73bb9001 252 guest-console
4cdeb0d0 253 hyperspec"
8e08f814 254[ "$xstuff" ] && scripts="$scripts
3bdada49 255 xinitcmd
34a5ea4e 256 un-backslashify-selection
c02999e8 257 lock-screen
b7743290 258 xpra-start-xdummy
8e08f814 259 xshutdown"
e04c4857
MW
260echo "Installing scripts..."
261mkdir -p $HOME$sub/bin
262for s in $scripts; do
263 ft=$HOME$sub/bin/$s
99063107 264 ln -s $here/bin/$s $ft.new
e04c4857
MW
265 mv $ft.new $ft
266 echo " $s"
267done
268echo " all done."
269
4d7d040b
MW
270hacks="
271 ssh:ssh"
272echo "Installing hacks..."
273for h in $hacks; do
274 d=${h%%:*} h=${h#*:}
275 ft=$HOME$sub/bin/hacks/$d
276 mkdir -p $ft
277 ln -s $here/hacks/$h $ft/$h.new
278 mv $ft/$h.new $ft/$h
279 echo " $d:$h"
280done
281echo " all done."
282
ce178f96
MW
283###--------------------------------------------------------------------------
284### Set up the Emacs config.
285
65ff0e8c
MW
286$echon "Finding a suitable emacs:$echoc"
287emacs=no
5fe24792 288for i in emacs22 emacs23 emacs21 emacs; do
65ff0e8c
MW
289 if type -p >/dev/null $i; then
290 emacs=$i
291 break
292 fi
293done
294if [ $emacs = no ]; then
295 echo " failed."
296 emacs=:
297else
298 echo " $emacs."
299fi
300
f617db13 301echo "Installing Emacs packages..."
400223a1
MW
302emacspkg="
303 make-regexp
a1293ade 304 ew-hols
a3bdb4d9 305 mdw-gnus-patch
1778b496 306 git git-blame vc-git stgit
c6fe19d5 307 mdw-multiple-cursors
400223a1
MW
308 quilt"
309for elib in $emacspkg; do
f617db13 310 $echon " $elib:$echoc"
65ff0e8c 311 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 312 (progn
852cd5fb
MW
313 (setq load-path (nconc load-path (list "~/lib/emacs")))
314 (kill-emacs (condition-case nil
315 (progn (load-library "'"$elib"'") 0)
20eb0692 316 (error 1))))'; then
f617db13
MW
317 echo " already installed."
318 else
99063107
MW
319 if [ -f el/$elib.el ]; then
320 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
321 else
322 $echon " downloading$echoc"
323 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
324 fi
f617db13
MW
325 $echon " compiling$echoc"
326 (cd $HOME$sub/lib/emacs;
65ff0e8c 327 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 328 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
329 echo " done."
330 fi
331done
852cd5fb 332echo " all done."
f617db13
MW
333
334$echon "Setting up Emacs configuration:$echoc"
335$echon " linking$echoc"
99063107 336for f in dot-emacs.el Makefile; do
f617db13 337 set -- $(echo $link | tr : ' ')
99063107
MW
338 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
339 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
340done
341$echon " compiling$echoc"
c39d1139 342{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
f617db13 343echo " done."
ce178f96
MW
344
345###----- That's all, folks --------------------------------------------------